// Example Java Code for the lecture on Graph Theory in DM534 by Daniel Merkle Nov. 8, 2018.
// For simplicity, no Exception Handling is implemented.

public class ShortestPaths {

    // Assume M and N are both square (size x size) matrices 
    public static int[][] multiplyModSquared(int[][] M, int[][] N) {
	int inf = Integer.MAX_VALUE;
	
        int size = M.length;

        int[][] C = new int[size][size];
        for (int i = 0; i < size; i++) {
            for (int j = 0; j < size; j++) {
		C[i][j] = inf;
            }
        }

	int add;
        for (int i = 0; i < size; i++) { 
            for (int j = 0; j < size; j++) { 
                for (int k = 0; k < size; k++) {
		    if (M[i][k] == inf || N[k][j] == inf)
			C[i][j] = Math.min(C[i][j], inf);
		    else
			C[i][j] = Math.min(C[i][j], M[i][k] + N[k][j]);
                }
            }
        }

        return C;
    }

    public static void printMatrix(int[][] M) {
	int inf = Integer.MAX_VALUE;
	for (int i = 0; i < M.length; i++) {
	    for (int j = 0; j < M[0].length; j++)
		if (M[i][j] == inf)
		    System.out.print("inf ");
		else
		    System.out.print(String.format("%3d ",M[i][j]));
            System.out.println();
        }
	System.out.println();
    }

    public static void main(String[] args) {
	int inf = Integer.MAX_VALUE;

	int[][] W = {{   0,   1, inf, inf,   2, inf}, 
		     {   1,   0,   2, inf,   4, inf}, 
		     { inf,   2,   0, inf, inf,   3}, 
		     { inf, inf, inf,   0,   6,   1}, 
		     {   2,   4, inf,   6,   0, inf}, 
		     { inf, inf,   3,   1, inf,   0}};

	int size = W.length;
	
	int[][] R = W.clone();

	System.out.println("Initial Matrix W :");
	printMatrix(W);
	
	for (int i = 2; i < 5; i++) {
	    System.out.println(i+"-th modified power of W :");
	    R = multiplyModSquared(W, R);
	    printMatrix(R);
	}
    }
}
